using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Globalization;
using System.IO;
using System.Text;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ī޶  Ʈ
        /// </summary>
        private List<CameraInfo> cameraInfoList = new List<CameraInfo>();

        /// <summary>
        /// /Ȯ
        /// </summary>
        private float zoom = 1;

        /// <summary>
        ///  X ǥ
        /// </summary>
        private int startX = 0;

        /// <summary>
        ///  Y ǥ
        /// </summary>
        private int startY = 0;

        /// <summary>
        /// ̵ X ǥ
        /// </summary>
        private int moveX = 0;

        /// <summary>
        /// ̵ Y ǥ
        /// </summary>
        private int moveY = 0;

        /// <summary>
        /// 
        /// </summary>
        private double measure = 0;

        /// <summary>
        /// ü ũ
        /// </summary>
        private double objectSize = 0;

        /// <summary>
        /// ü Ÿ
        /// </summary>
        private double objectDistance = 0;

        /// <summary>
        /// ü ũ 
        /// </summary>
        private double objectSizeScale = .01;

        /// <summary>
        /// ü Ÿ 
        /// </summary>
        private double objectDistanceScale = 1;

        /// <summary>
        ///   X ǥ
        /// </summary>
        private int measureStartX = 0;

        /// <summary>
        ///   Y ǥ
        /// </summary>
        private int measureStartY = 0;

        /// <summary>
        ///  
        /// </summary>
        private bool horizontal = true;

        /// <summary>
        /// Ʈ
        /// </summary>
        private Bitmap bitmap;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region   - MainForm()

        /// <summary>
        ///  
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            BuildCameraMenuItem();

            #region   ȭ ڸ Ѵ.

            this.openFileDialog.FileName         = "";
            this.openFileDialog.Filter           = "̹ |*.*|JPG|*.jpg";
            this.openFileDialog.RestoreDirectory = true;

            #endregion

            #region ̺Ʈ Ѵ.

            Load                                            += Form_Load;
            Resize                                          += Form_Resize;

            this.openImageMenuItem.Click                    += openImageMenuItem_Click;
            this.exitMenuItem.Click                         += exitMenuItem_Click;

            this.thumbnailPictureBox.MouseDown              += thumbnailPictureBox_MouseDown;
            this.zoomTrackBar.Scroll                        += zoomTrackBar_Scroll;
            this.foscalLengthTextBox.TextChanged            += foscalLengthTextBox_TextChanged;
            this.cameraFactoryTextBox.TextChanged           += cameraFactoryTextBox_TextChanged;
            this.sensorWidthTextBox.TextChanged             += foscalLengthTextBox_TextChanged;
            this.sensorHeightTextBox.TextChanged            += foscalLengthTextBox_TextChanged;

            this.objectSizeTextBox.Click                    += objectSizeTextBox_Click;
            this.objectSizeTextBox.TextChanged              += objectSizeTextBox_TextChanged;
            this.objectSizeScaleComboBox.TextChanged        += objectSizeScaleComboBox_TextChanged;
            this.objectSizeScaleComboBox.DropDownClosed     += objectSizeScaleComboBox_DropDownClosed;
            this.findDistanceButton.Click                   += findDistanceButton_Click;
            this.findSizeButton.Click                       += findSizeButton_Click;
            this.objectDistanceTextBox.Click                += objectDistanceTextBox_Click;
            this.objectDistanceTextBox.TextChanged          += objectDistanceTextBox_TextChanged;
            this.objectDistanceSacleComboBox.TextChanged    += objectDistanceSacleComboBox_TextChanged;
            this.objectDistanceSacleComboBox.DropDownClosed += objectDistanceSacleComboBox_DropDownClosed;
            this.moveImageButton.Click                      += moveImageButton_Click;
            this.measureButton.Click                        += measureButton_Click;

            this.mainPictureBox.MouseDown                   += mainPictureBox_MouseDown;
            this.mainPictureBox.MouseMove                   += mainPictureBox_MouseMove;

            #endregion
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region  ε óϱ - Form_Load(sender, e)

        /// <summary>
        ///  ε óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void Form_Load(object sender, EventArgs e)
        {
            UpdatePictureBox();
        }

        #endregion
        #region  ũ  óϱ - Form_Resize(sender, e)

        /// <summary>
        ///  ũ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void Form_Resize(object sender, EventArgs e)
        {
            UpdatePictureBox();
        }

        #endregion

        #region ̹  ޴ ׸ Ŭ óϱ - openImageMenuItem_Click(sender, e)

        /// <summary>
        /// ̹  ޴ ׸ Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void openImageMenuItem_Click(object sender, EventArgs e)
        {
            if(this.openFileDialog.ShowDialog() == DialogResult.OK)
            {
                string imageFilePath = this.openFileDialog.FileName;

                try
                {
                    Image image = Image.FromFile(imageFilePath);

                    this.thumbnailPictureBox.Image = image;

                    this.zoomTrackBar.Value = 50;

                    this.startX         = 0;
                    this.startY         = 0;
                    this.objectSize     = 0;
                    this.objectDistance = 0;
                    this.measure        = 0;

                    this.objectDistanceTextBox.Text = string.Empty;
                    this.objectSizeTextBox.Text     = string.Empty;

                    this.locationOnFileLabel.Text   = "ϻ ġ (pixel) : ";
                    this.locationOnSenserLabel.Text = " ġ (mm) : ";
                    this.sizeOnSensorLabel.Text     = " ũ (mm) : ";

                    this.imageWidthTextBox.Text    = string.Empty;
                    this.imageHeightTextBox.Text   = string.Empty;
                    this.foscalLengthTextBox.Text  = string.Empty;
                    this.cameraFactoryTextBox.Text = string.Empty;

                    SetZoom();

                    PropertyItem propertyItem = image.GetPropertyItem(37386);

                    byte[] lowByteArray  = new byte[propertyItem.Len / 2];
                    byte[] highByteArray = new byte[propertyItem.Len / 2];

                    Array.Copy(propertyItem.Value, 0                   , lowByteArray , 0, propertyItem.Len / 2);
                    Array.Copy(propertyItem.Value, propertyItem.Len / 2, highByteArray, 0, propertyItem.Len / 2);

                    this.foscalLengthTextBox.Text = Convert.ToString((float)GetUnsignedInteger(lowByteArray) / GetUnsignedInteger(highByteArray));

                    this.imageWidthTextBox.Text  = image.PhysicalDimension.Width.ToString();
                    this.imageHeightTextBox.Text = image.PhysicalDimension.Height.ToString();

                    if(image.PhysicalDimension.Width > image.PhysicalDimension.Height)
                    {
                        this.horizontal = true;
                    }
                    else
                    {
                        this.horizontal = false;
                    }

                    Encoding encoding = Encoding.ASCII;

                    string cameraFactory = encoding.GetString(image.GetPropertyItem(271).Value).Replace("\0", "\r\n");

                    cameraFactory += encoding.GetString(image.GetPropertyItem(272).Value);

                    this.cameraFactoryTextBox.Text = cameraFactory;

                    Text = "ī޶  ũ ϱ " + " - " + openFileDialog.FileName;
                }
                catch
                {
                }
            }
        }

        #endregion
        #region  ޴ ׸ Ŭ óϱ - exitMenuItem_Click(sender, e)

        /// <summary>
        ///  ޴ ׸ Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void exitMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        #endregion

        #region  ó ڽ 콺 DOWN óϱ - thumbnailPictureBox_MouseDown(sender, e)

        /// <summary>
        ///  ó ڽ 콺 DOWN óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void thumbnailPictureBox_MouseDown(object sender, MouseEventArgs e)
        {
            try
            {
                this.startX = this.thumbnailPictureBox.Image.Width  * e.X / this.thumbnailPictureBox.Width;
                this.startY = this.thumbnailPictureBox.Image.Height * e.Y / this.thumbnailPictureBox.Height;

                UpdatePictureBox();
            }
            catch
            {
            }
        }

        #endregion
        #region /Ȯ Ʈ ũѽ óϱ - zoomTrackBar_Scroll(sender, e)

        /// <summary>
        /// /Ȯ Ʈ ũѽ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void zoomTrackBar_Scroll(object sender, EventArgs e)
        {
            SetZoom();
        }

        #endregion
        #region  Ÿ ؽƮ ڽ ؽƮ  óϱ - foscalLengthTextBox_TextChanged(sender, e)

        /// <summary>
        ///  Ÿ ؽƮ ڽ ؽƮ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void foscalLengthTextBox_TextChanged(object sender, EventArgs e)
        {
            string equivalenceString = string.Empty;

            try
            {
                double equivalence = Math.Pow((Math.Pow(Convert.ToSingle(this.sensorWidthTextBox.Text), 2) + Math.Pow(Convert.ToSingle(this.sensorHeightTextBox.Text), 2)), 0.5);

                equivalence = Math.Round((43.2666153 / equivalence) * Convert.ToSingle(this.foscalLengthTextBox.Text));

                equivalenceString = equivalence.ToString();
            }
            catch
            {
            }

            this.equivalentTextBox.Text = equivalenceString;
        }

        #endregion
        #region ī޶  ؽƮ ڽ ؽƮ  óϱ - cameraFactoryTextBox_TextChanged(sender, e)

        /// <summary>
        /// ī޶  ؽƮ ڽ ؽƮ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void cameraFactoryTextBox_TextChanged(object sender, EventArgs e)
        {
            SearchCamera();
        }

        #endregion

        #region ü ũ ؽƮ ڽ Ŭ óϱ - objectSizeTextBox_Click(sender, e)

        /// <summary>
        /// ü ũ ؽƮ ڽ Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void objectSizeTextBox_Click(object sender, EventArgs e)
        {
            this.objectSizeTextBox.SelectionStart  = 0;
            this.objectSizeTextBox.SelectionLength = this.objectSizeTextBox.Text.Length;
        }

        #endregion
        #region ü ũ ؽƮ ڽ ؽƮ  óϱ - objectSizeTextBox_TextChanged(sender, e)

        /// <summary>
        /// ü ũ ؽƮ ڽ ؽƮ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void objectSizeTextBox_TextChanged(object sender, EventArgs e)
        {
            if(this.objectSizeTextBox.Selected)
            {
                try
                {
                    SetFindButton(true);

                    this.objectSize = Convert.ToDouble(this.objectSizeTextBox.Text) * this.objectSizeScale;

                    SetObjectDistance();
                }
                catch
                {
                }
            }
        }

        #endregion
        #region ü ũ  ޺ ڽ ؽƮ  óϱ - objectSizeScaleComboBox_TextChanged(sender, e)

        /// <summary>
        /// ü ũ  ޺ ڽ ؽƮ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void objectSizeScaleComboBox_TextChanged(object sender, EventArgs e)
        {
            this.objectSizeScale = GetSize(this.objectSizeScaleComboBox.Text);

            this.objectSizeTextBox.Text = Convert.ToString(Math.Round(this.objectSize / this.objectSizeScale, 2));
        }

        #endregion
        #region ü ũ  ޺ ڽ  ٿ   óϱ - objectSizeScaleComboBox_DropDownClosed(sender, e)

        /// <summary>
        /// ü ũ  ޺ ڽ  ٿ   óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void objectSizeScaleComboBox_DropDownClosed(object sender, EventArgs e)
        {
            this.zoomTrackBar.Select();
        }

        #endregion
        #region Ÿ ã ư Ŭ óϱ - findDistanceButton_Click(sender, e)

        /// <summary>
        /// Ÿ ã ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void findDistanceButton_Click(object sender, EventArgs e)
        {
            SetFindButton(true);
        }

        #endregion
        #region ũ ã ư Ŭ óϱ - findSizeButton_Click(sender, e)

        /// <summary>
        /// ũ ã ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void findSizeButton_Click(object sender, EventArgs e)
        {
            SetFindButton(false );
        }

        #endregion
        #region ü Ÿ ؽƮ ڽ Ŭ óϱ - objectDistanceTextBox_Click(sender, e)

        /// <summary>
        /// ü Ÿ ؽƮ ڽ Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void objectDistanceTextBox_Click(object sender, EventArgs e)
        {
            this.objectDistanceTextBox.SelectionStart  = 0;
            this.objectDistanceTextBox.SelectionLength = this.objectDistanceTextBox.Text.Length;
        }

        #endregion
        #region ü Ÿ ؽƮ ڽ ؽƮ  óϱ - objectDistanceTextBox_TextChanged(sender, e)

        /// <summary>
        /// ü Ÿ ؽƮ ڽ ؽƮ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void objectDistanceTextBox_TextChanged(object sender, EventArgs e)
        {
            if(this.objectDistanceTextBox.Selected)
            {
                try
                {
                    SetFindButton(false);

                    this.objectDistance = Convert.ToDouble(this.objectDistanceTextBox.Text) * this.objectDistanceScale;

                    SetObjectSize();
                }
                catch
                {
                }
            }
        }

        #endregion
        #region ü Ÿ  ޺ ڽ ؽƮ  óϱ - objectDistanceSacleComboBox_TextChanged(sender, e)

        /// <summary>
        /// ü Ÿ  ޺ ڽ ؽƮ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void objectDistanceSacleComboBox_TextChanged(object sender, EventArgs e)
        {
            this.objectDistanceScale = GetSize(this.objectDistanceSacleComboBox.Text);

            this.objectDistanceTextBox.Text = Convert.ToString(Math.Round(this.objectDistance / this.objectDistanceScale, 2));
        }

        #endregion
        #region ü Ÿ  ޺ ڽ  ٿ   óϱ - objectDistanceSacleComboBox_DropDownClosed(sender, e)

        /// <summary>
        /// ü Ÿ  ޺ ڽ  ٿ   óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void objectDistanceSacleComboBox_DropDownClosed(object sender, EventArgs e)
        {
            this.zoomTrackBar.Select();
        }

        #endregion
        #region ̹ ̵ ư Ŭ óϱ - moveImageButton_Click(sender, e)

        /// <summary>
        /// ̹ ̵ ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void moveImageButton_Click(object sender, EventArgs e)
        {
            this.moveImageButton.Checked = true;

            this.measureButton.Checked = false;

            this.mainPictureBox.Cursor = Cursors.Hand;
        }

        #endregion
        #region  ư Ŭ óϱ - measureButton_Click(sender, e)

        /// <summary>
        ///  ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void measureButton_Click(object sender, EventArgs e)
        {
            this.moveImageButton.Checked = false;

            this.measureButton.Checked = true;

            this.mainPictureBox.Cursor = Cursors.Cross;
        }

        #endregion

        #region  ó ڽ 콺 DOWN óϱ - mainPictureBox_MouseDown(sender, e)

        /// <summary>
        ///  ó ڽ 콺 DOWN óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void mainPictureBox_MouseDown(object sender, MouseEventArgs e)
        {
            if(this.moveImageButton.Checked)
            {
                this.moveX = e.X;
                this.moveY = e.Y;
            }
            else
            {
                this.measureStartX = e.X;
                this.measureStartY = e.Y;
            }
        }

        #endregion
        #region  ó ڽ 콺 ̵ óϱ - mainPictureBox_MouseMove(sender, e)

        /// <summary>
        ///  ó ڽ 콺 ̵ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void mainPictureBox_MouseMove(object sender, MouseEventArgs e)
        {
            if(e.Button == MouseButtons.Left)
            {
                if(this.moveImageButton.Checked)
                {
                    this.startX -= e.X - this.moveX;

                    if(this.startX < 0)
                    {
                        this.startX = 0;
                    }

                    this.startY -= e.Y - this.moveY;

                    if(this.startY < 0)
                    {
                        this.startY = 0;
                    }

                    this.moveX = e.X;
                    this.moveY = e.Y;

                    UpdatePictureBox();
                }
                else
                {
                    try
                    {
                        double differenceX = Math.Abs(this.measureStartX - e.X) * this.zoom * Convert.ToSingle(this.horizontal ? this.sensorWidthTextBox.Text  : this.sensorHeightTextBox.Text) / Convert.ToSingle(this.imageWidthTextBox.Text );
                        double differenceY = Math.Abs(this.measureStartY - e.Y) * this.zoom * Convert.ToSingle(this.horizontal ? this.sensorHeightTextBox.Text : this.sensorWidthTextBox.Text ) / Convert.ToSingle(this.imageHeightTextBox.Text);

                        this.measure = Math.Pow((Math.Pow(differenceX, 2) + Math.Pow(differenceY, 2)), 0.5);

                        this.sizeOnSensorLabel.Text = " ũ (mm) : " + this.measure.ToString();
                        
                        this.mainPictureBox.Refresh();

                        Graphics graphics = mainPictureBox.CreateGraphics();

                        graphics.ResetClip();

                        graphics.DrawLine(new Pen(Color.Red), this.measureStartX, this.measureStartY, e.X, e.Y);

                        if(this.findDistanceButton.Checked)
                        {
                            SetObjectDistance();
                        }
                        else
                        {
                            SetObjectSize();
                        }
                    }
                    catch
                    {
                    }
                }
            }

            try
            {
                float fileX = this.startX + e.X * this.zoom;
                float fileY = this.startY + e.Y * this.zoom;

                float sensorX = fileX * Convert.ToSingle(this.horizontal ? this.sensorWidthTextBox.Text  : this.sensorHeightTextBox.Text) / Convert.ToSingle(this.imageWidthTextBox.Text );
                float sensorY = fileY * Convert.ToSingle(this.horizontal ? this.sensorHeightTextBox.Text : this.sensorWidthTextBox.Text ) / Convert.ToSingle(this.imageHeightTextBox.Text);
                
                this.locationOnFileLabel.Text  = "ϻ ġ (pixel) X :" + fileX.ToString() + " Y : " + fileY.ToString();
                this.locationOnSenserLabel.Text= " ġ (mm) X : " + sensorX.ToString() + "  Y : " + sensorY.ToString();
            }
            catch
            {
            }
        }

        #endregion

        #region ī޶ ޴ ׸ Ŭ óϱ - cameraMenuItem_Click(sender, e)

        /// <summary>
        /// ī޶ ޴ ׸ Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void cameraMenuItem_Click(object sender, EventArgs e)
        {
            this.cameraFactoryTextBox.Text = ((ToolStripItem)sender).OwnerItem.Text;
            this.cameraFactoryTextBox.Text += "\r\n" + ((ToolStripItem)sender).OwnerItem.Text + " " + ((ToolStripItem)sender).Text;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region ī޶ ޴ ׸ ϱ - BuildCameraMenuItem()

        /// <summary>
        /// ī޶ ޴ ׸ ϱ
        /// </summary>
        private void BuildCameraMenuItem()
        {
            this.cameraInfoList.Clear();

            this.cameraMenuItem.DropDownItems.Clear();

            string cameraListFilePath = Path.Combine(Application.StartupPath, @"DATA\CameraList.info");

            if(File.Exists(cameraListFilePath))
            {
                string content = File.ReadAllText(cameraListFilePath);

                string[] lineArray = content.Split('\n');

                CultureInfo cultureInfo = new CultureInfo("en-US");

                foreach(string line in lineArray)
                {
                    if(string.IsNullOrWhiteSpace(line))
                    {
                        continue;
                    }

                    if(line.StartsWith("//"))
                    {
                        continue;
                    }

                    string[] tokenArray = line.Split(new string[] { "," }, StringSplitOptions.None);

                    try
                    {
                        CameraInfo cameraInfo = new CameraInfo();

                        cameraInfo.Factory      = tokenArray[0].Trim();
                        cameraInfo.Model        = tokenArray[1].Trim();
                        cameraInfo.AliasName    = tokenArray[2].Trim();
                        cameraInfo.SensorType   = tokenArray[3].Trim();
                        cameraInfo.SensorWidth  = Single.Parse(tokenArray[4], cultureInfo);
                        cameraInfo.SensorHeight = Single.Parse(tokenArray[5], cultureInfo);

                        this.cameraInfoList.Add(cameraInfo);

                        bool newFactory = true;

                        foreach(ToolStripMenuItem menuItem in this.cameraMenuItem.DropDownItems)
                        {
                            if(menuItem.Text.Contains(cameraInfo.Factory))
                            {
                                newFactory = false;

                                break;
                            }
                        }

                        if(newFactory)
                        {
                            this.cameraMenuItem.DropDownItems.Add(cameraInfo.Factory);
                        }

                        foreach(ToolStripMenuItem menuItem in this.cameraMenuItem.DropDownItems)
                        {
                            if(menuItem.Text.Contains(cameraInfo.Factory))
                            {
                                menuItem.DropDownItems.Add(cameraInfo.Model + (cameraInfo.AliasName == "" ? "" : " - " + cameraInfo.AliasName ), null, cameraMenuItem_Click);
                            }
                        }
                    }
                    catch
                    {
                    }
                }
            }
        }

        #endregion
        #region ó ڽ Ʈ ϱ - UpdatePictureBox()

        /// <summary>
        /// ó ڽ Ʈ ϱ
        /// </summary>
        private void UpdatePictureBox()
        {
            try
            {
                this.bitmap = new Bitmap(this.mainPictureBox.Width, this.mainPictureBox.Height);

                Graphics bitmapGraphics = Graphics.FromImage(this.bitmap);

                bitmapGraphics.SmoothingMode = SmoothingMode.AntiAlias;

                bitmapGraphics.DrawImage
                (
                    this.thumbnailPictureBox.Image,
                    new Rectangle(0, 0, this.mainPictureBox.Width, this.mainPictureBox.Height),
                    new Rectangle(this.startX, this.startY, (int)(this.mainPictureBox.Width * this.zoom), (int)(this.mainPictureBox.Height * this.zoom)),
                    GraphicsUnit.Pixel
                );

                this.mainPictureBox.Image = this.bitmap;
            }
            catch
            {
            }
        }

        #endregion
        #region ī޶ ã - SearchCamera()

        /// <summary>
        /// ī޶ ã
        /// </summary>
        private void SearchCamera()
        {
            this.sensorTypeTextBox.Text   = string.Empty;
            this.sensorHeightTextBox.Text = string.Empty;
            this.sensorWidthTextBox.Text  = string.Empty;

            this.cameraPictureBox.Image = null;

            this.toolTip.SetToolTip(this.cameraPictureBox, string.Empty);

            string searchControl = "MRK";
            string camereName    = this.cameraFactoryTextBox.Text.Replace(" ", "").Replace("-", "").ToLower() + searchControl;
            bool   cameraFound   = false;
            byte   cameraLoop    = 0;

            do
            {
                foreach(CameraInfo cameraInfo in this.cameraInfoList)
                {
                    if(camereName.Contains(cameraInfo.Factory.Replace(" ", "").ToLower()) && !cameraFound)
                    {
                        if(camereName.Contains(cameraInfo.Model.Replace(" ", "").Replace("-", "").ToLower() + searchControl) || (camereName.Contains(cameraInfo.AliasName.Replace(" ", "").Replace("-", "").ToLower() + searchControl) && cameraInfo.AliasName != ""))
                        {
                            this.sensorTypeTextBox.Text   = cameraInfo.SensorType;
                            this.sensorWidthTextBox.Text  = cameraInfo.SensorWidth.ToString();
                            this.sensorHeightTextBox.Text = cameraInfo.SensorHeight.ToString();

                            this.toolTip.SetToolTip(this.cameraPictureBox, cameraInfo.Factory + " " + cameraInfo.Model);

                            string cameraImageFilePath = Application.StartupPath + "\\Data\\" + cameraInfo.Factory + "_" + cameraInfo.Model.Replace(" ", "").Replace("-", "") + ".gif";

                            if(File.Exists(cameraImageFilePath))
                            {
                                this.cameraPictureBox.Image = Image.FromFile(cameraImageFilePath);
                            }

                            cameraFound = true;
                        }
                    }
                }

                searchControl = string.Empty;

                cameraLoop++;
            }
            while(!cameraFound && cameraLoop < 2);
        }

        #endregion
        #region /Ȯ ϱ - SetZoom()

        /// <summary>
        /// /Ȯ ϱ
        /// </summary>
        private void SetZoom()
        {
            this.zoom = 50 / (float)zoomTrackBar.Value;

            this.toolTip.SetToolTip(zoomTrackBar ,"  : " + Convert.ToString((100 / this.zoom)) + "%");

            UpdatePictureBox();
        }

        #endregion
        #region ȣ   ϱ - GetUnsignedInteger(sourceArray)

        /// <summary>
        /// ȣ   ϱ
        /// </summary>
        /// <param name="sourceArray">ҽ 迭</param>
        /// <returns>ȣ  </returns>
        private uint GetUnsignedInteger(byte[] sourceArray)
        {
            if(sourceArray.Length != 4)
            {
                return 0;
            }
            else
            {
                return Convert.ToUInt32(sourceArray[3] << 24 | sourceArray[2] << 16 | sourceArray[1] << 8 | sourceArray[0]);
            }
        }

        #endregion
        #region ü Ÿ ϱ - SetObjectDistance()

        /// <summary>
        /// ü Ÿ ϱ
        /// </summary>
        private void SetObjectDistance()
        {
            this.objectDistanceTextBox.Text = string.Empty;

            try
            {
                this.objectDistance = this.objectSize / (this.measure / Convert.ToDouble(this.foscalLengthTextBox.Text));

                this.objectDistanceTextBox.Text = Convert.ToString(Math.Round(this.objectDistance / this.objectDistanceScale, 2));
            }
            catch
            {
            }
        }

        #endregion
        #region ü ũ ϱ - SetObjectSize()

        /// <summary>
        /// ü ũ ϱ
        /// </summary>
        private void SetObjectSize()
        {
            this.objectSizeTextBox.Text = string.Empty;

            try
            {
                this.objectSize = this.objectDistance * (this.measure / Convert.ToDouble(this.foscalLengthTextBox.Text));

                this.objectSizeTextBox.Text = Convert.ToString(Math.Round(this.objectSize / this.objectSizeScale, 2));
            }
            catch
            {
            }
        }

        #endregion
        #region ã ư ϱ - SetFindButton(isChecked)

        /// <summary>
        /// ã ư ϱ
        /// </summary>
        /// <param name="isChecked">üũ </param>
        private void SetFindButton(bool isChecked)
        {
            this.findDistanceButton.Checked = isChecked;
            this.findSizeButton.Checked     = !isChecked;

            if(isChecked)
            {
                SetObjectDistance();
            }
            else
            {
                SetObjectSize();
            }
        }

        #endregion
        #region ũ ϱ - GetSize(sizeUnit)

        /// <summary>
        /// ũ ϱ
        /// </summary>
        /// <param name="sizeUnit">ũ </param>
        /// <returns>ũ</returns>
        private double GetSize(string sizeUnit)
        {
            switch(sizeUnit.Trim().ToLower())
            {
                case "mm"   : return .001;
                case "cm"   : return .01;
                case "m"    : return 1;
                case "km"   : return 1000;
                case "inch" : return .0254;
                case "foot" : return .3048;
                case "mile" : return 1609.344;
            }

            return 0;
        }

        #endregion
    }
}